<template>
  <section class="appMap branchesMap">
    <header class="appMap-header">
      <button
        @click="$emit('change-subsection', 'mobile')"
        class="buttonBack">
        Списком
        <img
          svg-inline
          src="~/assets/svg/redesign/arrow-left-bold.svg">
      </button>
    </header>
    <AppAbstractMap
      :placemarks="entities"
      :init-coords="entities[0]"
      :active-entity-index="activeEntityIndex"
      :with-balloon="true"
      :hint-configuration="$options.hintConfiguration"
      @choose-entity="onChooseEntity"
      :bus="bus"/>
      <!-- <AppEntitiesList
      active-tab="branches"
      :entities="entities"
      :entity-component="entity"
      :active-entity-index="activeEntityIndex"
      :has-list="hasList"
      :tabs="tabs"
      :bus="bus">
      <template v-slot:item="{ idx, id, active }">
        <EntityShop
          :entity="entities[idx]"
          :key="idx"
          :active-element="active"
          :index="idx"
          @select-entity="onChooseEntity($event)"/>
      </template>
      <EntityShop
        slot="active-entity"
        :entity="entities[activeEntityIndex]"
        :active-element="true"/>
    </AppEntitiesList> -->
  </section>
</template>

<script>
import { debounce } from 'lodash-es';
import Vue from 'vue';
import Placemark from '~/assets/js/enums/placemark';

import AppAbstractMap from '~/components/redesign/app-map/app-abstract-map';
import EntityShop from '~/components/redesign/entities/entity-shop';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppMapBalloon from '~/components/redesign/app-map/app-map-balloon';
import MapHintRegular from '~/components/redesign/app-map/map-hint-regular';
import AppEntitiesList from '~/components/redesign/entities/app-entities-list';

export default {
  name: 'BranchesInMap',
  components: {
    AppAbstractMap,
    AppButton,
    EntityShop,
    AppEntitiesList,
  },
  props: {
    location: {
      type: String,
      default: '',
    },
    entities: {
      type: Array,
      default() {
        return [];
      },
    },
  },
  data() {
    return {
      activeEntityIndex: 0,
      entity: EntityShop,
      bus: new Vue(),
      hasList: false,
      screenWidth: null,
    };
  },
  computed: {
    tabs() {
      return {
        branches: {
          name: 'Филиалы магазина',
          count: this.entities.length,
        },
      };
    },
  },
  created() {
    this.$options.balloonConfiguration = {
      template: AppMapBalloon,
      type: Placemark.SHOP,
    };
    this.$options.hintConfiguration = {
      template: MapHintRegular,
      type: Placemark.SHOP,
    };
    this.debouncedResizeHandler = debounce(this.onResizeHandler, 250);
    window.addEventListener('resize', this.debouncedResizeHandler);
  },
  mounted() {
    this.bus.$on('select-entity', ([itemIndex = 0]) => {
      this.activeEntityIndex = itemIndex;
      this.interacted = true;
      this.hasList = false;
    });
  },
  destroyed() {
    this.bus.$off('select-entity');
    window.removeEventListener('resize', this.debouncedResizeHandler);
  },
  methods: {
    onChooseEntity(index) {
      this.activeEntityIndex = index;
      this.hasList = false;
    },
    onSelectEntity([index = 0]) {
      this.activeEntityIndex = index;
      this.hasList = false;
    },
    onResizeHandler() {
      ({ width: this.screenWidth } = window.screen);
    },
  },
};
</script>

<style lang="postcss">
  .appMap.branchesMap {
    position: relative;
    width: 100%;

    .appAbstractMap, .ymap-container {
      height: inherit;
    }

    .appMap-header {
      padding-top: 1.5rem;

      .buttonBack {
        display: none;
      }
    }

    .entitiesList {
      position: absolute;
      top: 4rem;

      &-options {
        .buttonAsLink {
          padding: 0 1.25rem;
          height: 2.5rem;
          color: var(--color-main);

          .button-item {
            display: flex;
            align-items: center;
          }

          .svg {
            margin-left: 0.25rem;
            width: 0.5625rem;
            height: 0.25rem;
            fill: var(--color-main-lightest);
          }
        }
      }
    }

    @media screen and (max-width: 980px) {
      position: fixed;
      z-index: calc(var(--z-index-over-modal) - 1);
      top: 0;
      bottom: 0;
      left: 0;
      width: 100vw;
      min-width: 20rem;
      height: 100vh;

      .appMap-header {
        position: absolute;
        z-index: 1;
        top: 0;
        width: 100vw;
        min-width: 20rem;

        .button, .heading {
          display: none;
        }

        .buttonBack {
          position: absolute;
          top: 2.75rem;
          left: 0.5rem;
          display: flex;
          justify-content: center;
          align-items: center;
          padding: 0;
          width: 3.75rem;
          height: 3.75rem;
          font-size: 0;
          border: none;
          outline: none;
          border-radius: 50%;
          background-color: rgba(255,255,255,0.8);
          box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);
          .svg {
            margin: 0;
            fill: var(--color-main);
          }
        }

        .buttonFilters {
          position: absolute;
          top: 1rem;
          right: 1rem;
          display: flex;
          background-color: rgba(255,255,255,0.8);
          box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);
          .button-item {
            display: inline-flex;
            align-items: center;
            font-size: 1rem;
            font-weight: var(--font-weight-medium);
          }
          .svg {
            margin-right: 0.5rem;
            width: 1rem;
            height: auto;
            fill: var(--color-main);
          }
        }
      }

      .entitiesList {
        position: absolute;
        top: auto;
        bottom: 0;
        height: auto;
        width: 100vw;
        min-width: 20rem;

        &-options {
          justify-content: flex-start;

          .buttonAsLink {
            height: 4rem;
            color: var(--color-main-lightest);

            .button-item {
              font-size: 1rem;
            }

            .svg {
              margin-left: 0.5rem;
              width: 0.75rem;
              height: 0.375rem;
            }
          }
        }
      }
    }
  }
</style>
